package it.eng.spago.jbi.test.client;

import it.eng.spago.jbi.Constants;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.StringBufferInputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.logging.Logger;

public class HTTPClient {

	/**
	 * This class invokes a JBI component through a HTTP binding component.
	 * ServiceMix should be installed on the same machine, listening on port 8912
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		Logger logger = Logger.getLogger(Constants.SPAGO_LOGGER, null);

		String response = null;
		try {
			logger.info("Opening connection");

			URLConnection connection = new URL("http://localhost:8912")
					.openConnection();
			connection.setDoOutput(true);
			OutputStream os = connection.getOutputStream();

			logger.info("Sending stream");

			InputStream is = null;
			StringBufferInputStream sbis = new StringBufferInputStream(
					"<SERVICE_REQUEST ACTION_NAME=\"TEST_ACTION\" />");
			is = sbis;

			// Post the request file.
			// FileInputStream fis = new FileInputStream("C:\\test-action.xml");

			// Buffer
			byte[] buf = new byte[256];
			for (int c = is.read(buf); c != -1; c = is.read(buf)) {
				os.write(buf, 0, c);
			}
			os.close();
			is.close();

			// Read the response.
			logger.info("Reading response");
			StringBuffer buffer = new StringBuffer();
			BufferedReader in = new BufferedReader(new InputStreamReader(
					connection.getInputStream()));
			String inputLine;
			while ((inputLine = in.readLine()) != null) {
				buffer.append(inputLine);
			}
			in.close();
			response = buffer.toString();
			logger.info("Response message: " + response);

		} catch (Exception ex) {
			logger.severe(ex.getMessage());
		}

	}

}
